import constants
import activities.activity_optimal_classification as optimal_classification
import activities.activity_machine_learning as machine_learning


def start(username=''):
    if username == '':
        print "Please specify subject username in 'main.py'"
    search = 1
    el = constants.electrodes_motor_cortex.index(constants.cp4[0])
    imf_index = 3
    ratio = 0.88

    if search:

        baselines = [150, 175, 200, 250, 300, 350, 400, 450, 500, 550]
        desyncs = [1100, 1150, 1200, 1250, 1300, 1400, 1450, 1500, 1550, 1600, 1700, 1750, 1800, 1900, 2000]

        score_threshold = 70.00
        best_score = 50
        best_baseline = 150
        best_desync = 1100

        for base in range(len(baselines)):

            for sync in range(len(desyncs)):
                score = optimal_classification.start(username, el, baselines[base], desyncs[sync], ratio, imf_index)

                if score > score_threshold:
                    if score > best_score:
                        best_score = score
                        best_baseline = baselines[base]
                        best_desync = desyncs[sync]
                    introduction = "Accuracy " + str(score) + " with params: " + str(baselines[base]) + ', ' + \
                                   str(desyncs[sync])
                    print("\n%s\n%s\n%s" % ('-' * len(introduction), introduction, '-' * len(introduction)))

        print "Finished! Best score = " + str(best_score)
        print "Baseline = " + str(best_baseline)
        print "Desync length = " + str(best_desync)
        print "IMF index = " + str(imf_index)
        if best_score >= score_threshold:
            machine_learning.start(username, el, best_baseline, best_desync, ratio, imf_index)
        else:
            print "No acceptable classification results..."

    else:
        baseline = 250
        desync_length = 1550
        machine_learning.start(username, el, baseline, desync_length, ratio, imf_index)